



<!DOCTYPE html>
<html lang="en" class="no-js">
  <head>
    
      <meta charset="utf-8">
      <meta name="viewport" content="width=device-width,initial-scale=1">
      <meta http-equiv="x-ua-compatible" content="ie=edge">
      
      
      
      
        <meta name="lang:clipboard.copy" content="Copy to clipboard">
      
        <meta name="lang:clipboard.copied" content="Copied to clipboard">
      
        <meta name="lang:search.language" content="en">
      
        <meta name="lang:search.pipeline.stopwords" content="True">
      
        <meta name="lang:search.pipeline.trimmer" content="True">
      
        <meta name="lang:search.result.none" content="No matching documents">
      
        <meta name="lang:search.result.one" content="1 matching document">
      
        <meta name="lang:search.result.other" content="# matching documents">
      
        <meta name="lang:search.tokenizer" content="[\s\-]+">
      
      <link rel="shortcut icon" href="../assets/images/favicon.png">
      <meta name="generator" content="mkdocs-1.0.4, mkdocs-material-3.0.6">
    
    
      
        <title>Custom Expression Functions - QGIS + Python = ❤❤</title>
      
    
    
      <link rel="stylesheet" href="../assets/stylesheets/application.451f80e5.css">
      
        <link rel="stylesheet" href="../assets/stylesheets/application-palette.22915126.css">
      
      
        
        
        <meta name="theme-color" content="#4caf50">
      
    
    
      <script src="../assets/javascripts/modernizr.1aa3b519.js"></script>
    
    
      
        <link href="https://fonts.gstatic.com" rel="preconnect" crossorigin>
        <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Roboto:300,400,400i,700|Roboto+Mono">
        <style>body,input{font-family:"Roboto","Helvetica Neue",Helvetica,Arial,sans-serif}code,kbd,pre{font-family:"Roboto Mono","Courier New",Courier,monospace}</style>
      
    
    <link rel="stylesheet" href="../assets/fonts/material-icons.css">
    
    
  </head>
  
    
    
    <body dir="ltr" data-md-color-primary="green" data-md-color-accent="light-green">
  
    <svg class="md-svg">
      <defs>
        
        
      </defs>
    </svg>
    <input class="md-toggle" data-md-toggle="drawer" type="checkbox" id="__drawer" autocomplete="off">
    <input class="md-toggle" data-md-toggle="search" type="checkbox" id="__search" autocomplete="off">
    <label class="md-overlay" data-md-component="overlay" for="__drawer"></label>
    
      <a href="#custom-expression-functions" tabindex="1" class="md-skip">
        Skip to content
      </a>
    
    
      <header class="md-header" data-md-component="header">
  <nav class="md-header-nav md-grid">
    <div class="md-flex">
      <div class="md-flex__cell md-flex__cell--shrink">
        <a href=".." title="QGIS + Python = ❤❤" class="md-header-nav__button md-logo">
          
            <i class="md-icon"></i>
          
        </a>
      </div>
      <div class="md-flex__cell md-flex__cell--shrink">
        <label class="md-icon md-icon--menu md-header-nav__button" for="__drawer"></label>
      </div>
      <div class="md-flex__cell md-flex__cell--stretch">
        <div class="md-flex__ellipsis md-header-nav__title" data-md-component="title">
          
            
              <span class="md-header-nav__topic">
                QGIS + Python = ❤❤
              </span>
              <span class="md-header-nav__topic">
                Custom Expression Functions
              </span>
            
          
        </div>
      </div>
      <div class="md-flex__cell md-flex__cell--shrink">
        
          
            <label class="md-icon md-icon--search md-header-nav__button" for="__search"></label>
            
<div class="md-search" data-md-component="search" role="dialog">
  <label class="md-search__overlay" for="__search"></label>
  <div class="md-search__inner" role="search">
    <form class="md-search__form" name="search">
      <input type="text" class="md-search__input" name="query" placeholder="Search" autocapitalize="off" autocorrect="off" autocomplete="off" spellcheck="false" data-md-component="query" data-md-state="active">
      <label class="md-icon md-search__icon" for="__search"></label>
      <button type="reset" class="md-icon md-search__icon" data-md-component="reset" tabindex="-1">
        &#xE5CD;
      </button>
    </form>
    <div class="md-search__output">
      <div class="md-search__scrollwrap" data-md-scrollfix>
        <div class="md-search-result" data-md-component="result">
          <div class="md-search-result__meta">
            Type to start searching
          </div>
          <ol class="md-search-result__list"></ol>
        </div>
      </div>
    </div>
  </div>
</div>
          
        
      </div>
      
    </div>
  </nav>
</header>
    
    <div class="md-container">
      
        
      
      
      <main class="md-main">
        <div class="md-main__inner md-grid" data-md-component="container">
          
            
              <div class="md-sidebar md-sidebar--primary" data-md-component="navigation">
                <div class="md-sidebar__scrollwrap">
                  <div class="md-sidebar__inner">
                    <nav class="md-nav md-nav--primary" data-md-level="0">
  <label class="md-nav__title md-nav__title--site" for="__drawer">
    <a href=".." title="QGIS + Python = ❤❤" class="md-nav__button md-logo">
      
        <i class="md-icon"></i>
      
    </a>
    QGIS + Python = ❤❤
  </label>
  
  <ul class="md-nav__list" data-md-scrollfix>
    
      
      
      


  <li class="md-nav__item">
    <a href=".." title="Before We Start" class="md-nav__link">
      Before We Start
    </a>
  </li>

    
      
      
      


  <li class="md-nav__item">
    <a href="../python_console/" title="The Python Console and editor" class="md-nav__link">
      The Python Console and editor
    </a>
  </li>

    
      
      
      


  <li class="md-nav__item">
    <a href="../startup/" title="Startup Scripts" class="md-nav__link">
      Startup Scripts
    </a>
  </li>

    
      
      
      

  


  <li class="md-nav__item md-nav__item--active">
    
    <input class="md-toggle md-nav__toggle" data-md-toggle="toc" type="checkbox" id="__toc">
    
      
    
    
      <label class="md-nav__link md-nav__link--active" for="__toc">
        Custom Expression Functions
      </label>
    
    <a href="./" title="Custom Expression Functions" class="md-nav__link md-nav__link--active">
      Custom Expression Functions
    </a>
    
      
<nav class="md-nav md-nav--secondary">
  
  
    
  
  
    <label class="md-nav__title" for="__toc">Table of contents</label>
    <ul class="md-nav__list" data-md-scrollfix>
      
        <li class="md-nav__item">
  <a href="#workshop-examples" title="Workshop examples" class="md-nav__link">
    Workshop examples
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#understanding-custom-expressions" title="Understanding Custom Expressions" class="md-nav__link">
    Understanding Custom Expressions
  </a>
  
    <nav class="md-nav">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#breaking-down-the-function" title="Breaking down the function" class="md-nav__link">
    Breaking down the function
  </a>
  
</li>
        
      </ul>
    </nav>
  
</li>
      
        <li class="md-nav__item">
  <a href="#style-example" title="Style Example" class="md-nav__link">
    Style Example
  </a>
  
    <nav class="md-nav">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#exercise-change-the-style-of-the-pits-layer" title="Exercise: Change the style of the Pits layer" class="md-nav__link">
    Exercise: Change the style of the Pits layer
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#exercise-adding-a-new-function" title="Exercise: Adding a new function" class="md-nav__link">
    Exercise: Adding a new function
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#exercise-updating-function-code" title="Exercise: Updating function code." class="md-nav__link">
    Exercise: Updating function code.
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#exercise-using-the-function" title="Exercise: Using the function" class="md-nav__link">
    Exercise: Using the function
  </a>
  
</li>
        
      </ul>
    </nav>
  
</li>
      
        <li class="md-nav__item">
  <a href="#layout-example" title="Layout Example" class="md-nav__link">
    Layout Example
  </a>
  
    <nav class="md-nav">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#exercise-creating-the-new-function" title="Exercise: Creating the new function." class="md-nav__link">
    Exercise: Creating the new function.
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#exercise-using-the-new-function" title="Exercise: Using the new function" class="md-nav__link">
    Exercise: Using the new function
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#exercise-updating-the-rest-of-the-label" title="Exercise: Updating the rest of the label." class="md-nav__link">
    Exercise: Updating the rest of the label.
  </a>
  
</li>
        
      </ul>
    </nav>
  
</li>
      
      
      
      
      
    </ul>
  
</nav>
    
  </li>

    
      
      
      


  <li class="md-nav__item">
    <a href="../processing/" title="Processing Scripts" class="md-nav__link">
      Processing Scripts
    </a>
  </li>

    
      
      
      


  <li class="md-nav__item">
    <a href="../project_macros/" title="Project Macros" class="md-nav__link">
      Project Macros
    </a>
  </li>

    
      
      
      


  <li class="md-nav__item">
    <a href="../bonus/" title="Bonus Round!!" class="md-nav__link">
      Bonus Round!!
    </a>
  </li>

    
  </ul>
</nav>
                  </div>
                </div>
              </div>
            
            
              <div class="md-sidebar md-sidebar--secondary" data-md-component="toc">
                <div class="md-sidebar__scrollwrap">
                  <div class="md-sidebar__inner">
                    
<nav class="md-nav md-nav--secondary">
  
  
    
  
  
    <label class="md-nav__title" for="__toc">Table of contents</label>
    <ul class="md-nav__list" data-md-scrollfix>
      
        <li class="md-nav__item">
  <a href="#workshop-examples" title="Workshop examples" class="md-nav__link">
    Workshop examples
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#understanding-custom-expressions" title="Understanding Custom Expressions" class="md-nav__link">
    Understanding Custom Expressions
  </a>
  
    <nav class="md-nav">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#breaking-down-the-function" title="Breaking down the function" class="md-nav__link">
    Breaking down the function
  </a>
  
</li>
        
      </ul>
    </nav>
  
</li>
      
        <li class="md-nav__item">
  <a href="#style-example" title="Style Example" class="md-nav__link">
    Style Example
  </a>
  
    <nav class="md-nav">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#exercise-change-the-style-of-the-pits-layer" title="Exercise: Change the style of the Pits layer" class="md-nav__link">
    Exercise: Change the style of the Pits layer
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#exercise-adding-a-new-function" title="Exercise: Adding a new function" class="md-nav__link">
    Exercise: Adding a new function
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#exercise-updating-function-code" title="Exercise: Updating function code." class="md-nav__link">
    Exercise: Updating function code.
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#exercise-using-the-function" title="Exercise: Using the function" class="md-nav__link">
    Exercise: Using the function
  </a>
  
</li>
        
      </ul>
    </nav>
  
</li>
      
        <li class="md-nav__item">
  <a href="#layout-example" title="Layout Example" class="md-nav__link">
    Layout Example
  </a>
  
    <nav class="md-nav">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#exercise-creating-the-new-function" title="Exercise: Creating the new function." class="md-nav__link">
    Exercise: Creating the new function.
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#exercise-using-the-new-function" title="Exercise: Using the new function" class="md-nav__link">
    Exercise: Using the new function
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#exercise-updating-the-rest-of-the-label" title="Exercise: Updating the rest of the label." class="md-nav__link">
    Exercise: Updating the rest of the label.
  </a>
  
</li>
        
      </ul>
    </nav>
  
</li>
      
      
      
      
      
    </ul>
  
</nav>
                  </div>
                </div>
              </div>
            
          
          <div class="md-content">
            <article class="md-content__inner md-typeset">
              
                
                
                <h1 id="custom-expression-functions">Custom Expression Functions</h1>
<p><strong>API Note:</strong> Any QGIS APIs referenced will link out to the <a href="https://qgis.org/pyqgis/master">Python API Docs</a>.</p>
<p>Custom expression functions are a powerful feature in QGIS that allow you to extend the expression engine to do exactly as you need
without being limited to what as been added to the core expression functions in each release.</p>
<p>As we can use Python for these custom expressions we are able to pretty much do anything we need when the need comes.</p>
<h3 id="workshop-examples">Workshop examples</h3>
<ul>
<li>Custom functions we can use in styles</li>
<li>Custom functions we can use in layouts</li>
</ul>
<h2 id="understanding-custom-expressions">Understanding Custom Expressions</h2>
<p>Custom expression functions can be added inside the expression builder using the expression Function Editor tab.  You can access this panel though any expression dialog:</p>
<p><img alt="Function Editor" src="../img/function_editor.png" /></p>
<p>Before we start we will break down the parts of a expression function just to understand how it works:</p>
<pre><code>@qgsfunction(args='auto', group='Workshop')
def render_real_size(sizelabel, feature, parent):
    &quot;&quot;&quot;
    Render the real size of the stormwater feature given the
    label with the size.
    &quot;&quot;&quot;
    pass
</code></pre>

<h3 id="breaking-down-the-function">Breaking down the function</h3>
<pre><code>@qgsfunction(args='auto', group='Workshop')
</code></pre>

<p>The <code>qgsfunction</code> marks the method as a custom QGIS expression function.
<code>args='auto'</code> means the function will try and work out the number of required args based on the function signature.
<code>group='Workshop'</code> the group in the function tree to include this new function in.</p>
<pre><code>def render_real_size(sizelabel, feature, parent):
</code></pre>

<p>The normal Python function definition.  <code>feature</code> and <code>parent</code> are always the last argument to be to passed in and are required.</p>
<ul>
<li><code>feature</code> is a <a href="https://qgis.org/pyqgis/master/core/Feature/QgsFeature.html">QgsFeature</a> object which contains the geometry object as well as the attribute data.</li>
<li><code>parent</code> is a <a href="https://qgis.org/pyqgis/master/core/Expression/QgsExpression.html">QgsExpression</a> containing the current expression being parsed.</li>
<li><code>context</code> (optional) a optional forth argument is a <a href="https://qgis.org/pyqgis/master/core/Expression/QgsExpressionContext.html">QgsExpressionContext</a>. This can be used to get access to
expression variables and other information that has been added for the expression.</li>
</ul>
<p>Each argument before the three above is required to be included when the function is called when included in the expression. The case above <code>sizelabel</code> is the only argument
so when we call the function inside the expression it will be called as: <code>render_real_size("label")</code>.</p>
<pre><code>    &quot;&quot;&quot;
    Render the real size of the stormwater feature given the
    label with the size.
    &quot;&quot;&quot;
</code></pre>

<p>The method doc string.  Anything here will show up as help for the function in the expression builder. HTML supported.</p>
<pre><code>    pass
</code></pre>

<p>The function body will update with logic we need.</p>
<h2 id="style-example">Style Example</h2>
<p>In this example we are going to use the <code>Pits</code> layer that contains a Label field with the following style data:</p>
<p><img alt="Function Editor" src="../img/pitsize.png" /></p>
<p>The real size of the pit is in a label as "wdithxheight". We can extract this out and render the real size of the pit on the map using a custom function
and the geometry generator symbol type.</p>
<p>The final result should look like this:</p>
<p><img alt="Function Editor" src="../img/style_output.png" /></p>
<p>We will be using the <strong>Pits</strong> layer for the following examples so feel free to disable the other layers.</p>
<h4 id="exercise-change-the-style-of-the-pits-layer">Exercise: Change the style of the Pits layer</h4>
<p>First we need to open the style dock for the Pits layer and change the symbol to <code>Geometry generator</code>. This symbol type allows us
to render a different type of geometry from the layers data. For example we can render a polygon from a point layer.</p>
<p><img alt="Function Editor" src="../img/geom_gen.png" /></p>
<p>Leave the geometry type as <code>Polygon/MuliPolygon</code> as that is what we want to render.</p>
<p>Click the insert expression button to insert a new expression</p>
<p><img alt="Function Editor" src="../img/geom_layer.png" /></p>
<h4 id="exercise-adding-a-new-function">Exercise: Adding a new function</h4>
<p>Switch to the Function editor and click the Add button on the bottom right to create a new file called workshop.</p>
<p><img alt="Function Editor" src="../img/newfunction.png" /></p>
<p>The new function has now been created.</p>
<p><img alt="Function Editor" src="../img/newfunction_created.png" /></p>
<h4 id="exercise-updating-function-code">Exercise: Updating function code.</h4>
<p>Delete the new file contents and paste the following:</p>
<pre><code>from qgis.core import *
from qgis.gui import *
from PyQt5.QtCore import QRectF

@qgsfunction(args='auto', group='Workshop')
def render_real_size(sizelabel, feature, parent):
    &quot;&quot;&quot;
    Render the real size of the stormwater feature given the
    label with the size.
    &quot;&quot;&quot;
    geom = feature.geometry()
    centroid = geom.centroid().asPoint()
    splitdata = sizelabel.split(&quot;x&quot;)
    if len(splitdata) == 2:
        width, height = int(splitdata[0]) / 1000, int(splitdata[1]) / 1000
        x, y = centroid.x()-width/2,centroid.y()-height/2
        rect = QRectF(x, y, width, height)
        return QgsGeometry.fromWkt(QgsRectangle(rect).asWktPolygon())
</code></pre>

<p>The above function takes a string in the format of <code>widthxheight</code> and will return a real geometry object of that size around the
center of the object.</p>
<h4 id="exercise-using-the-function">Exercise: Using the function</h4>
<p>Press the Save and Load Functions to load it into the expression engine. </p>
<p><strong>Note</strong>: You will need to do this each time you want to reload your changes.</p>
<p>Switch back to the expression tab and enter the following:</p>
<pre><code>render_real_size(&quot;label&quot;)
</code></pre>

<p>In the output preview you will see <code>&lt;geometry:Polygon&gt;</code> which tells us the output is a polygon geometry type. 
Click OK on the expression editor and the map will refresh with the rendered pit size.</p>
<p>After you change the colours and add a label based on <code>label</code> property you will see the following:</p>
<p><img alt="Function Editor" src="../img/pit_size.png" /></p>
<h2 id="layout-example">Layout Example</h2>
<p>Custom expression functions can be used anywhere that expressions can be used, which includes in layouts.<br />
In this example we will create a layout which will show a summary of the layer values in the current map view.</p>
<p>The final result should look something this:</p>
<p><img alt="Function Editor" src="../img/layout_output.png" /></p>
<p>Enable the Trees layer in the project and open the layout called in <code>Layout Example</code></p>
<p>This layout has a single map view and a label that will contain out feature count.</p>
<h4 id="exercise-creating-the-new-function">Exercise: Creating the new function.</h4>
<p>Select the label and use <code>Insert an Expression..</code>. </p>
<p>Switch to the function editor and create a new function file called <code>layout</code> and paste the following:</p>
<pre><code>from qgis.core import *
from qgis.gui import *
from collections import Counter

@qgsfunction(args='auto', group='Workshop')
def feature_summary(mapextent, layername, field, feature, parent, context):
    maplayer = QgsProject.instance().mapLayersByName(layername)[0]
    data = [f[field] for f in maplayer.getFeatures(QgsFeatureRequest(mapextent.boundingBox()))]
    template = &quot;&lt;ul&gt;{0}&lt;/ul&gt;&quot;
    items = []
    for name, count in Counter(data).items():
        items.append(&quot;&lt;li&gt;{}: {}&lt;/li&gt;&quot;.format(count, name))
    return template.format(&quot;&quot;.join(items))
</code></pre>

<p>Click <code>Save and Load Functions</code></p>
<h4 id="exercise-using-the-new-function">Exercise: Using the new function</h4>
<p>The above function will take the map extent, layername, and field as arguments.  So we need to call it with
those values.</p>
<p>We get the map extent of our map using the <code>map_get</code> function.</p>
<pre><code>map_get(item_variables('MainMap'),'map_extent'))
</code></pre>

<p>However we still need to call our custom function.  </p>
<p>So lets call it and include it as the first arg:</p>
<pre><code>feature_summary( ( map_get(item_variables('MainMap'),'map_extent')), 'TREES', 'Type')
</code></pre>

<h4 id="exercise-updating-the-rest-of-the-label">Exercise: Updating the rest of the label.</h4>
<p>As layout labels allow for expressions inside <code>[% %]</code> blocks we can add extra headers in the raw label and even another row
for a different layer.</p>
<p>Update the label text to be the following</p>
<p><strong>Note</strong>: Note the use of HTML in this label.</p>
<pre><code>&lt;H1&gt;Tree  Type Count&lt;/h1&gt;

[% feature_summary( ( map_get(item_variables('MainMap'),'map_extent')), 'TREES', 'Type') %]

&lt;H1&gt;Pit Type Count&lt;/h1&gt;

[% feature_summary( ( map_get(item_variables('MainMap'),'map_extent')), 'PITS', 'Type') %]
</code></pre>

<p>You label box should look like this:</p>
<p><img alt="Function Editor" src="../img/layout_label.png" /></p>
<p>and the layout output should now be:</p>
<p><img alt="Function Editor" src="../img/layout_output.png" /></p>
<p>Don't forget to ticket <strong>Render as HTML</strong> for the label.</p>
                
                  
                
              
              
                


              
            </article>
          </div>
        </div>
      </main>
      
        
<footer class="md-footer">
  
    <div class="md-footer-nav">
      <nav class="md-footer-nav__inner md-grid">
        
          <a href="../startup/" title="Startup Scripts" class="md-flex md-footer-nav__link md-footer-nav__link--prev" rel="prev">
            <div class="md-flex__cell md-flex__cell--shrink">
              <i class="md-icon md-icon--arrow-back md-footer-nav__button"></i>
            </div>
            <div class="md-flex__cell md-flex__cell--stretch md-footer-nav__title">
              <span class="md-flex__ellipsis">
                <span class="md-footer-nav__direction">
                  Previous
                </span>
                Startup Scripts
              </span>
            </div>
          </a>
        
        
          <a href="../processing/" title="Processing Scripts" class="md-flex md-footer-nav__link md-footer-nav__link--next" rel="next">
            <div class="md-flex__cell md-flex__cell--stretch md-footer-nav__title">
              <span class="md-flex__ellipsis">
                <span class="md-footer-nav__direction">
                  Next
                </span>
                Processing Scripts
              </span>
            </div>
            <div class="md-flex__cell md-flex__cell--shrink">
              <i class="md-icon md-icon--arrow-forward md-footer-nav__button"></i>
            </div>
          </a>
        
      </nav>
    </div>
  
  <div class="md-footer-meta md-typeset">
    <div class="md-footer-meta__inner md-grid">
      <div class="md-footer-copyright">
        
        powered by
        <a href="https://www.mkdocs.org">MkDocs</a>
        and
        <a href="https://squidfunk.github.io/mkdocs-material/">
          Material for MkDocs</a>
      </div>
      
        
      
    </div>
  </div>
</footer>
      
    </div>
    
      <script src="../assets/javascripts/application.5e60981f.js"></script>
      
      <script>app.initialize({version:"1.0.4",url:{base:".."}})</script>
      
    
    
      
    
  </body>
</html>